
#include "TWindow.h"
#include "XCopy.h"
#include "TView.h"


#include "StorageKit.h"

	
main()
{	
	XCopyApplication	myApplication;

	myApplication.Run();

	return(0);
}

XCopyApplication::XCopyApplication()
		  		  : BApplication("application/x-vnd.slema-xcopy")
{
init_params();

	
	BRect			aRect;

	// set up a rectangle and instantiate a new window
	aRect.Set(100, 80, 100+414, 80+300);
	mainWindow = new TWindow(aRect);
	
	#define MAX_WIDTH  380
	#define MAX_HEIGHT 580
	
	//minWidth,MaxWidth,... minheight,maxheight
	mainWindow->SetSizeLimits(mainWindow->Bounds().Width()-1,MAX_HEIGHT ,
						   mainWindow->Bounds().Height()-1,MAX_WIDTH);	
	mainWindow->SetZoomLimits(MAX_WIDTH ,MAX_HEIGHT);

	// make window visible
	mainWindow->Show();

	

}


bool XCopyApplication::QuitRequested()
{
/*
BPath pth;
BEntry x;
if ( x.SetTo(DEFAULT_TEMP_FILE,B_READ_WRITE)==B_OK ) 
	{
		find_directory( B_TRASH_DIRECTORY, &pth, false, NULL);
		
		BDirectory y(pth.Path());
		x.MoveTo(&y,pth.Path(),true);

//ATTENTION Lä ça remplace la corbeille faut un strcat à la fin du  nom!
		
	}
*/

	//	if ( x.SetTo(DEFAULT_TEMP_FILE".gz",B_READ_WRITE)==B_OK  ) x.delete;


system("rm "DEFAULT_TEMP_FILE); //delete the temp_file
system("rm "DEFAULT_TEMP_FILE".gz"); //delete the compressed temp in case it crashed without erasing it

return true;
}

//---------------------------------


//---------------------------------------------------------
//BIG THANKS TO TYLER RITI FOR writing the base of the following functions...
//It surely would have taken me years to understand how to do it alone ;-)
//---------------------------------------------------------

int32 start_engines(void *obj); //prototype to avoid warning

int32 start_engines(void *obj)
{
    // Take the pointer and cast it to the XCopyApplication type.
    // Call the StartEngines() method on it.
    return ((XCopyApplication *)obj)->StartEngines();
}

void XCopyApplication::ArgvReceived(int32 argc, char **argv)
{

    
   // These two variables are private members of the XCopyApplication class
    arg_count = argc;

//    arg_values = argv; //we can't just do that since the pointer might not be valid anymore
						 //which is the case when invoking from command-line  

 
arg_values = new char *[argc];
for (int32 i = 0; i < argc; ++i)
{
	arg_values[i] = new char[strlen(argv[i]) + 1];
	strcpy(arg_values[i], argv[i]); // I hope this isn't backwards!
}

    
    // Spawn a thread and give the thread function a pointer to
    // this object.

    ptg.dd_thread = spawn_thread(start_engines, "dd_function", 
        B_NORMAL_PRIORITY, (void *)this);
    resume_thread(ptg.dd_thread);
    
    //save the thread id in order to be able to kill it if needed (canceled download)
    
}

int32 XCopyApplication::StartEngines(void)
{
    // We are still in the engine_thread but now we can access
    // arg_count and arg_values because we've got access to
    // the implicit 'this' pointer.
    
    // Print the arguments
    	printf("\n\nArguments passed to the original DD main function \n");
	    for (int32 i = 0; i < arg_count; ++i)
  	  	printf("%ld: %s\n", i, arg_values[i]);

   
   mainWindow->SetPulseRate(THE_RATE);
   text_main(arg_count, arg_values); 
    return 1;
}


void  XCopyApplication::RefsReceived(BMessage *le_message)
{
	//copy the file as default temp_file so that dd can read from it

	entry_ref ref; 
       		 
	le_message->FindRef("refs", &ref); 
	
	PostMessage(CLEAR_SOURCE);
	
	BEntry entry(&ref);
	BPath the_path; 
	char str[2200];
	char txt[2048];
	entry.GetPath(&the_path);
	sprintf(txt,the_path.Path());


	bool is_gzipped=false;
	BString s = txt;
	if (s.FindFirst(".gz")>0) is_gzipped=true;
	
	mainWindow->Lock();
	mainWindow->theView->status->SetText("Please wait while loading file...");
	mainWindow->theView->info->SetText("");
	mainWindow->Unlock();



	//add '' in case there are spaces in the names!
	sprintf(str,"cp '");
	strcat(str,txt);
	strcat(str,"' '");
	strcat(str,DEFAULT_TEMP_FILE);
	if (is_gzipped==true) strcat(str,".gz");  //pour pouvoir décompresser faut 
											  //qu'il y ait le gz
											  //c'est gzip qui est comme ça...				
	strcat(str,"'");  //closing quote
	system(str);

	//do not add '&' since we have to wait for the file to be copied before we uncompress.
	
	if (is_gzipped==true) 
	{
		mainWindow->Lock();
		mainWindow->theView->status->SetText("Please wait while uncompressing file...");
		mainWindow->Unlock();

		system("gunzip "DEFAULT_TEMP_FILE".gz -f"); //force overwrite
	}
	
	mainWindow->Lock();
	mainWindow->theView->status->SetText("Disk image loaded.");
	
	
	BFile t(DEFAULT_TEMP_FILE,B_READ_ONLY);
	off_t sz; t.GetSize(&sz);
	mainWindow->theView->total_read = (int32)sz;

	char le_txt[255];
	sprintf(le_txt,"%ld sectors read.",(int32)sz/512);
	mainWindow->theView->info->SetText(le_txt);
	
	mainWindow->Unlock();
	
	got_things_to_write=true;

	mainWindow->PostMessage(new BMessage(FILL_SOURCE));
	mainWindow->PostMessage(new BMessage(DO_ENABLE_ALL));
	 						
}






void XCopyApplication::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		case B_SAVE_REQUESTED:
		
		message->FindRef( "directory", &Directory );
		message->FindString( "name",  &FileName);

		entry = &Directory;
		entry.GetPath(&the_path);
		sprintf(txt,the_path.Path());
		strcat(txt,"/");
		strcat(txt,FileName);

		mainWindow->Lock();
		mainWindow->theView->status->SetText("Please wait while saving file...");
		mainWindow->theView->status->Draw(mainWindow->theView->Bounds());
		mainWindow->Unlock();


		sprintf(str,"cp '");
		strcat(str,DEFAULT_TEMP_FILE); 	strcat(str,"' '"); strcat(str,txt);  strcat(str,"' ");
		system(str);
			
		if (mainWindow->zip_or_not->Value() == B_CONTROL_ON)
			{
				mainWindow->Lock();
				mainWindow->theView->status->SetText("Please wait while compressing file...");
				mainWindow->theView->status->Draw(mainWindow->theView->Bounds());
				mainWindow->Unlock();

				sprintf(str,"gzip '");
				strcat(str,txt);
				strcat(str,"' ");
				system(str);

			}
	
				mainWindow->Lock();
				mainWindow->theView->status->SetText("Image saved.");
				mainWindow->theView->status->Draw(mainWindow->theView->Bounds());
				mainWindow->Unlock();
			

		break;
		
		
		
		default:
			BApplication::MessageReceived(message);
	}
}
