#include "TView.h"

#include <fs_info.h>

#define BORDER 1
#define MAX_SECTORS 72
#define PER_LINE 12

AniView::AniView(BRect rect)
	   	   : BView(rect,"", B_FOLLOW_ALL , B_WILL_DRAW | B_PULSE_NEEDED | B_FULL_UPDATE_ON_RESIZE)
{
	active_img=26;

	//Extraction des gifs en bbitmap
	int32 i =0;
	while (i!=29+1)
	{
		les_pics[i] = BTranslationUtils::GetBitmap('RAWT', i, NULL);
		if (les_pics[i]==NULL) les_pics[i] = new BBitmap(BRect(0,0,90-1,90-1-9),B_RGB32);
		i++;
	}


	
}


void AniView::Pulse()
{

thread_info inf;

if (get_thread_info(ptg.dd_thread,&inf)==B_OK || active_img!=26) //si la thread existe on anime
	{
		if (active_img != 29) active_img++;
		else active_img=0;
		Draw(Bounds());	
	}
	else
	{	
	    Window()->SetPulseRate(0);
	    if (got_things_to_write==true) 	Window()->PostMessage(DO_ENABLE_ALL);
	    else {
	    			Window()->PostMessage(DO_ENABLE_READ);
	    	}
	}
	
}

void AniView::Draw(BRect update)
{
	DrawBitmap(les_pics[active_img],update,update);
}


void AniView::MouseDown(BPoint pt)
{
	Window()->PostMessage(new BMessage(ABOUT_BOX));
}


BlockView::BlockView(BRect rect, const char *name)
	   	   : BView(rect, name, B_FOLLOW_ALL , B_WILL_DRAW | B_FULL_UPDATE_ON_RESIZE)
{
SetViewColor(64,64,64);


//----------------------------------------------------------

/*
Hé, grand con!
LIS CA SI TU TE SOUVIENS PAS COMMENT CA MARCHAIT!
DONC ä LA BASE LES PICS DOIVENT ÈTRE EN 8 BITS MAIS COMME LES TRANSLATORS
CONVERTISSENT AUTOMATIQUEMENT EN 32 ON EST OBLIGE DE RECONVERTIR
ET POUR RETROUVER LES MEMES VALEURS AUX MEMES EMPLACEMENTS ON EST OBLIGES 
D'avoiR DES PICS EN NIVEAUX DE GRIS. VU QUE FORCEMENT LE GRIS EN RGB CA CHANGE PAS
LA PALETTE DES PICS EN GRIS DOIT DONC AVOIR POUR
LA COULEUR 0.... R:0 G:0 B:0
LA COULEUR 2.... R:2 G:2 B:2
et ainsi de suite... on peut pas faire autrement. Parait que c'est comme ça
les B_CMAP8 sont avec la palette fixe du systeme point final. Les CMAP8 tels que je les utilise
peuvent pas etres affichés avec un bete DrawBitmap vu que la palette inclue dans le BBitmap
n'est pas la bonne.
*/


	pic_32 = BTranslationUtils::GetBitmap('RGBB',111);
		if (pic_32==NULL) pic_32 = new BBitmap(BRect(0,0,89,89),B_RGB32);//just in case resources are missing
   	pic = new BBitmap(pic_32->Bounds(), B_CMAP8); //pic en niveaux de gris
   
   	unsigned char *dest = (unsigned char*) pic->Bits();   
   	unsigned char *bts  = (unsigned char*) pic_32->Bits();   

   	int32 pos=0;
   	int32 leng=pic->BitsLength();	
   	while (pos != leng+1)
         {
           *dest=*bts; //copie que le rouge
           dest++; pos++;
           bts+=4;
          }	
             
//après ça pic32 sera utilisé pour l'affichage...


ClearIt();

}

void BlockView::ClearIt()
{

int32 x = 0;
while (x != 255+1) { SetPal(x,x,x,x); x++; } //dégradé bas en haut dans les coul

SetPal(255,255,255,255);	//255 = shine color to white
SetPal(200,0,0,0);	//200 = border color to black
UpdatePic();
Draw(Bounds());
}


void BlockView::SetPal(uint8 which_one, uint8 r, uint8 g, uint8 b)
{
	palette[0][which_one] = b; 
	palette[1][which_one] = g;
	palette[2][which_one] = r;
}


void BlockView::UpdatePic()
{
				
pic->Lock();   
pic_32->Lock();   

//c'est 90x90 alors on se fait pas chier on update la pic en entier

   	unsigned char *cmapped = (unsigned char*) pic->Bits();   
   	unsigned char *bts     = (unsigned char*) pic_32->Bits();   

   	int32 pos=0;
   	int32 leng=pic->BitsLength();	

   	while (pos != leng - (18*9)) //pourquoi -162?? parce-que sinon çA dépasse et ça merdouille en haut..
 							  //je comprends pas mais bon...
         {
           *bts = palette[0][*cmapped]; bts++;  //b 
           *bts = palette[1][*cmapped]; bts++;  //g
           *bts = palette[2][*cmapped]; bts++;	//r
           bts++; //alpha           
           cmapped++; pos++;
          }	

pic->Unlock();   
pic_32->Unlock();   

}




void BlockView::Draw(BRect zone)
{

if (pic_32!=NULL && (pic_32->IsLocked()==false )) 
	DrawBitmap(pic_32,pic->Bounds(),this->Bounds());

}



TView::TView(BRect rect, const char *name)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW | B_PULSE_NEEDED )
{


SetViewColor(216,216,216);


BRect the_rect;

BRect box_rect,inside_box, rect_blocks,button_right_rect,button_left_rect;

box_rect.Set(0,0,90-1+16+8,90-1-9+16+16+64);
box_rect.OffsetBy(8,8);
BBox *aa = new BBox(box_rect,"aaa",B_FOLLOW_ALL, B_WILL_DRAW , B_FANCY_BORDER);
aa->SetLabel("Source");

inside_box.Set(0,0,90-1+8,90-1-9+8);
inside_box.OffsetBy(8,8+8);
src = new BBox(inside_box,"aaa",B_FOLLOW_ALL, B_WILL_DRAW , B_PLAIN_BORDER);

rect_blocks.Set(0,0,90-1,90-1-9);
rect_blocks.OffsetBy(4,4);
blocks_src = new BlockView(rect_blocks,"source");


//the buttons
button_left_rect.top = inside_box.bottom+8;
button_left_rect.InsetBy(8,8);
button_left_rect.right = button_left_rect.left+48;
button_left_rect.bottom = button_left_rect.top+23;
CreateButton(110,111);
read = new BPictureButton(button_left_rect,"",off, off, new BMessage(READ_IT),B_ONE_STATE_BUTTON);
read->SetDisabledOn(on); read->SetDisabledOff(on);
bb_help.SetHelp(read,"Read sectors from disk");

button_right_rect = button_left_rect;
button_right_rect.OffsetBy(50,0);
CreateButton(112,113);
load = new BPictureButton(button_right_rect,"",off, off, new BMessage(LOAD_IT),B_ONE_STATE_BUTTON);
load->SetDisabledOn(on); load->SetDisabledOff(on);
bb_help.SetHelp(load,"Load disk image from file");

//--------

//au mêmes positions que l'autre

box_rect.OffsetBy(128,0);
BBox *bb = new BBox(box_rect,"aaa",B_FOLLOW_ALL, B_WILL_DRAW , B_FANCY_BORDER);
bb->SetLabel("Destination");

dest = new BBox(inside_box,"aaa",B_FOLLOW_RIGHT | B_FOLLOW_TOP_BOTTOM, B_WILL_DRAW, B_PLAIN_BORDER);
blocks_dest = new BlockView(rect_blocks,"dest");

//the buttons
CreateButton(114,115);
write = new BPictureButton(button_left_rect,"",off, off, new BMessage(WRITE_IT),B_ONE_STATE_BUTTON);
write->SetDisabledOn(on); write->SetDisabledOff(on);
bb_help.SetHelp(write,"Write sectors to disk");

CreateButton(116,117);
save = new BPictureButton(button_right_rect,"",off, off, new BMessage(SAVE_IT),B_ONE_STATE_BUTTON);
save->SetDisabledOn(on); save->SetDisabledOff(on);
bb_help.SetHelp(save,"Save disk image to file");

the_rect = button_left_rect;
the_rect.OffsetBy(0,23+2);
the_rect.right+=50;
CreateButton(118,119);
boot = new BPictureButton(the_rect,"",off, off, new BMessage(BOOT_IT),B_ONE_STATE_BUTTON);
boot->SetDisabledOn(on); boot->SetDisabledOff(on);
bb_help.SetHelp(boot,"Create a BeOS boot floppy");


//---------


the_rect = Bounds();
the_rect.InsetBy(6,6);
the_rect.top = the_rect.bottom-80;
BBox *border_info = new BBox(the_rect,"aaa",B_FOLLOW_BOTTOM | B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW | B_FULL_UPDATE_ON_RESIZE, B_FANCY_BORDER);

the_rect = border_info->Bounds();
the_rect.InsetBy(4,8);
the_rect.bottom = the_rect.top+14;

status = new BStringView(the_rect,"info","");
status->SetFont(be_bold_font);
the_rect.OffsetBy(0,16);
info = new BStringView(the_rect,"status","");
the_rect.OffsetBy(0,16);
image_name = new BStringView(the_rect,"name","Temporary storage file: "DEFAULT_TEMP_FILE);


///----------------------------------------------------------------------

the_rect.Set(0,0,90-1,90-1-9);
the_rect.OffsetBy(288,80);
ani_view = new AniView(the_rect);
AddChild(ani_view);

///----------------------------------------------------------------------
/*
the_rect.top =8;
the_rect.bottom =8+14;
the_rect.left = box_rect.right+16;
the_rect.right = Bounds().right-8;

BMenu *mode_menu = new BMenu("Mode");
BMenuItem *it;
mode_menu->AddItem(it = new BMenuItem("High Density (1.44 Mb)", new BMessage(MODE_1440)));
mode_menu->AddItem(new BMenuItem("Low Density (720 kb)",  new BMessage(MODE_720)));
it->SetMarked(true);
mode_menu->SetLabelFromMarked(true); //pour mettre nom actif en titre
mode = new BMenuField(the_rect,"",NULL,mode_menu, B_FOLLOW_LEFT,B_WILL_DRAW);
mode_menu->SetLabelFromMarked(true); //pour mettre nom actif en titre
AddChild(mode);
*/
///----------------------------------------------------------------------



//-----------------------

AddChild(aa);
AddChild(bb);

aa->AddChild(src);  src->AddChild(blocks_src);
bb->AddChild(dest); dest->AddChild(blocks_dest);

AddChild(border_info);
border_info->AddChild(status);
border_info->AddChild(info);
border_info->AddChild(image_name);

aa->AddChild(read);
aa->AddChild(load);

bb->AddChild(write);
bb->AddChild(save);
bb->AddChild(boot);

write->SetEnabled(false);
save->SetEnabled(false);


warnings= new BCheckBox(BRect(6,190,Bounds().Width()-6,190+12), "warn", "Disable warnings when writing to floppy.",  new BMessage(WARNING_CHANGED),
							B_FOLLOW_TOP, B_WILL_DRAW);

AddChild (warnings);



r_step=0;
w_step=0;

r_old_step = 0; 
w_old_step = 0; 

}




void TView::MouseDown(BPoint pos)
{

uint32 buttons;
BPoint pt;
GetMouse(&pt,&buttons);
if (buttons==B_SECONDARY_MOUSE_BUTTON) Window()->PostMessage(new BMessage(ABOUT_BOX));

/*
fs_info inf;
fs_stat_dev(dev_for_path("/dev/disk/floppy/"), &inf); 
		char str[255];	
		sprintf(str,"\nblocks: %ld",int32(inf.total_blocks)); 
		printf(str);
*/
}

void TView::Pulse()
{

char str[255];

	if (is_reading==true)
	{
	//READ


	if (current_read_pos > 0)
	{

		r_step = (current_read_pos / 40)-1; //((double(2880) / 81))); // div par 35.555555

		sprintf(str,"%ld sectors read (%ld kb).",current_read_pos-40,(how_many_bytes_read/1024)-20);
		info->SetText(str);

		if (r_step >= r_old_step ) //si plus grand ou si c'est le dernier ou premier
		{	
			
			blocks_src->SetPal(int8(r_step),0,255-r_step,0);	
			blocks_src->UpdatePic(); 	
			blocks_src->Draw(blocks_src->Bounds());
			
			//printf("\nRStep: %ld",r_step);
	
		//after the update is done we go back to dark green (it will show up on on next update)
		blocks_src->SetPal(int8(r_step),0,200-r_step,0);	 //the previous back_to normal
		
		}


		if (current_read_pos >= 2880)	
			{
					blocks_src->SetPal(71,0,200-71,0);	

					EnableAll(); //Enable buttons
					status->SetText("Waiting");
					got_things_to_write=true;
					blocks_src->UpdatePic(); 	//to set the last back to normal color
					blocks_src->Draw(blocks_src->Bounds());
		
			}	

		if (has_aborted==true)
			{
					EnableAll(); //Enable buttons
					status->SetText("Reading aborted because of an error.");
					blocks_src->SetPal(r_step,220,0,0);	
					blocks_src->UpdatePic(); 	
					blocks_src->Draw(blocks_src->Bounds());
			}	
			
		r_old_step = r_step;	

		
	}
	}
	else
	{		
	//WRITE
	if (current_write_pos > 0)
	{

		w_step = (current_write_pos / 40)-1; //((double(2880) / 81))); // div par 35.555555

		sprintf(str,"%ld sectors written (%ld kb).",current_write_pos-40,(how_many_bytes_written/1024)-20);
		info->SetText(str);
			
		if ( w_step >= w_old_step) //si plus grand
		{	
			
			blocks_src->SetPal(int8(w_step),0,255-w_step,0);	 //the active one shines
			blocks_dest->SetPal(int8(w_step),0,255-w_step,0);	

			blocks_src->UpdatePic(); 	
			blocks_dest->UpdatePic(); 	
			blocks_src->Draw(blocks_src->Bounds());
			blocks_dest->Draw(blocks_dest->Bounds());

		//after the update is done
		blocks_src->SetPal(int8(w_step),0,200-w_step,0);	 //the previous back_to normal
		blocks_dest->SetPal(int8(w_step),0,200-w_step,0);	 //the previous back_to normal
		
		}
		
		w_old_step = w_step;	
		
		if (current_write_pos >= 2880)	
			{
					blocks_dest->SetPal(71,0,200-71,0);	
					
					EnableAll(); //Enable buttons
					status->SetText("Waiting");
					blocks_src->UpdatePic(); 	//to set the last back to normal color
					blocks_dest->UpdatePic(); 	//to set the last back to normal color
					blocks_src->Draw(blocks_src->Bounds());
					blocks_dest->Draw(blocks_dest->Bounds());
				}	

		if (has_aborted==true)
			{
					EnableAll(); //Enable buttons
					status->SetText("Writing aborted because of an error.");
					blocks_dest->SetPal(w_step,220,0,0);	
					blocks_dest->UpdatePic(); 	
					blocks_dest->Draw(blocks_dest->Bounds());					
					
			}	
	
	}
	}	

}


void TView::DisableAll()
{
		read->SetEnabled(false);
		write->SetEnabled(false);
		load->SetEnabled(false);
		save->SetEnabled(false);
		boot->SetEnabled(false);

}

void TView::EnableAll()
{
		read->SetEnabled(true);
		write->SetEnabled(true);
		load->SetEnabled(true);
		save->SetEnabled(true);
		boot->SetEnabled(true);

}


void TView::CreateButton(int32 enabled_id ,int32 disabled_id)
{
			
			BWindow *tmp_win = new BWindow(BRect(0,0,32,32),"",B_DOCUMENT_WINDOW,Flags(),B_CURRENT_WORKSPACE);
			
			//fill bitmap
			downBitmap = BTranslationUtils::GetBitmap('RAWT', enabled_id, NULL);
			upBitmap = BTranslationUtils::GetBitmap('RAWT', disabled_id, NULL);
			
			//avoid crash if missing
			if (downBitmap==NULL) downBitmap = new BBitmap(BRect(0,0,15,15),B_RGB32);
			if (upBitmap==NULL) upBitmap = new BBitmap(BRect(0,0,15,15),B_RGB32);
			
			BRect rect = downBitmap->Bounds();

			//Faut un window pour le faire
			BWindow* x= new BWindow(rect,"", B_FLOATING_WINDOW, Flags(), B_CURRENT_WORKSPACE);
			
			//tempview for creating the picture
			BView *tempView = new BView( rect, "temp", B_FOLLOW_NONE, B_WILL_DRAW );
			x->AddChild(tempView);
			
			//create on picture
   			tempView->BeginPicture(new BPicture); 
   			tempView->DrawBitmap(upBitmap);
   			on = tempView->EndPicture();
   			//create off picture
   			tempView->BeginPicture(new BPicture); 
   			tempView->DrawBitmap(downBitmap);
   			off = tempView->EndPicture();
   			//get rid of tempview
   			
   			x->RemoveChild(tempView);
   			x->Close();
			delete upBitmap;
   			delete downBitmap;
   			
}
