#ifndef T_VIEW_H
#define T_VIEW_H

#include <View.h>
#include "TShare.h"

#define MODE_1440 'md14'
#define MODE_720 'md72'

#define WARNING_CHANGED 'wnch'

class BlockView : public BView 
{
public:
	BlockView(BRect frame, const char *name); 
	
	virtual void Draw(BRect zone);
	
	BBitmap *pic,*pic_32;
	uint8 palette[3][256];
	void UpdatePic();
	void ClearIt();

	int16 current_block;

	void SetPal(uint8 which_one, uint8 r, uint8 g, uint8 b);
	

};

class AniView : public BView 
{
public:
	AniView(BRect frame); 

virtual void Draw(BRect x);	
virtual void Pulse();	
int16 active_img;
BBitmap *les_pics[29];
virtual void MouseDown(BPoint pos);

};


class TView : public BView 
{
public:
	TView(BRect frame, const char *name); 

virtual void MouseDown(BPoint pos);
	int32 total_read;

BBox *dest,*src;
BlockView *blocks_src,*blocks_dest;
BPictureButton *read, *write, *load, *save,*boot;
BStringView *status,*info, *image_name;
virtual void Pulse();
int32 r_old_step, w_old_step;
int32 r_step, w_step;

BCheckBox *warnings;

void EnableAll();
void DisableAll();

void CreateButton(int32 enabled_id ,int32 disabled_id);

AniView *ani_view;
BMenuField *mode;

	BBitmap* downBitmap;
	BBitmap* upBitmap;
   	BPicture *on,*off;
   	
   
};

#endif 
